// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
EXPORT void linecpy(char *ob,char *buf);
EXPORT ul write_as_stereo(int fd,short *vbuf,ul  b);
EXPORT ul sz2ms(ul sz,ul speed,ul channels);
EXPORT ul simple_gen_note(ul offs,short *buf,ul sz,ul srate,ul hz,ul *xtra_hz);
EXPORT void *strrstr_q(void *haystack,void *search_start,void *needle,int ign);
EXPORT ul strip_man_chars(char *buf,ul b);
EXPORT int isdigits(char *fn);
EXPORT int spawnvp1(int nowait,char *fn,char **av);
EXPORT int _pcm_find_avg(void  *vbuf,ul sz);
EXPORT char *_arg_dbl_q(char *p);
EXPORT char *_arg_sngl_q(char *p);
EXPORT void _arg_find_end(char **p);
#ifdef  WIN32
#endif
EXPORT void *_cmalloc(ul sz);
EXPORT void _cfree(nmalloc_t *ptr);
EXPORT int _is_dev(int md);
EXPORT int _recv(int s,void *b,ul n);
#ifdef WIN32
#endif
EXPORT int _send(int s,void *b,ul n);
EXPORT ul _simple_gen_note(short *buf,ul sz,ul srate,ul hz,ul *xtra_hz);
EXPORT ul _string2args(char *buf,int *ac,char **av,ul max_sz);
EXPORT void *_xmalloc(ul n);
EXPORT void *_xrealloc(void *rc,ul n);
EXPORT int _xspawn(char *cmdl,int in_pipe,int out_pipe,int err_pipe);
EXPORT char *arg_find_end(char *p);
EXPORT ul asc2bytes(void *buf,void *ibuf,ul n);
EXPORT void asc2note(char *note,ul *p,ul *d,ul *v);
EXPORT int asc2percent(char *ptr,int max_dec);
EXPORT ul ascii2g1brl(char *ob,char *b);
EXPORT unsigned short *ascii2w(char *s);
EXPORT void asciify(char *b,ul n);
EXPORT ul block_resample(ul fsz,us *buf,us *obuf,ul israte,us ichan,ul osrate);
EXPORT us bmp_get_pad(ul scanw);
EXPORT ul bmp_init(char *buf,void  **pmem,ul *ctb_sz,ul **ctab,ul *scanw,void **img);
EXPORT uc brl_comp_num(int ch);
EXPORT uc brl_comp_num2ascii(int ch);
EXPORT uc brl_punc(int ch);
EXPORT uc brl_punc2ascii(int ch);
EXPORT void bsort(void *s,ul n,fooptr foo);
EXPORT int buf_write(fn_ptr_t foo,int fd,void *buf,ul sz,void *b,ul n);
EXPORT uc bufread(bufread_t *b,char **bf,uc binary_mode);
EXPORT ul catprintf(char *buf,ul mx,char *fmt,...);
EXPORT ul cdrom_addr2n(void *a);
EXPORT ul cdrom_msf2n(char *msf);
EXPORT char * cdrom_n2msf(ul n);
EXPORT char *ch2wd(int ch);
EXPORT int check_file_reg(char *p,char  *fn,char *ifn,stat_t *sb);
EXPORT uc check_ucase(char *buf);
EXPORT int copy_bytes(int ifd,int ofd,ul n);
EXPORT ul count_lines(char *s);
EXPORT uc crc8(void *buff,ul sz);
EXPORT short deg_cos(int n);
EXPORT short deg_sin(int n);
EXPORT char *dirpart(char *ifn);
#ifdef WIN32
#endif
EXPORT void *envstr_match(char *v,char *nm,uc ic);
EXPORT int ext2_read_super(int fd,void *sb);
EXPORT ul fat_calc_fat_len(us x,us sec_per_cl,ul sec_sz,ul bp_cl,ul ts);
EXPORT ul fat_get_data_start(fat_boot_sec_t *bs);
EXPORT ul fat_get_fat_len(fat_boot_sec_t *bs);
EXPORT int fdgetc(int fd);
EXPORT int fdgets(char *b,ul sz,int fd);
#ifndef _d_use_inline
EXPORT ul fdprintf(int fd,char *str,...);
#endif
#ifndef _d_use_inline
EXPORT ul fdprints(int fd,char *buf);
#endif
EXPORT void fdprintsn(int fd,char *str);
EXPORT int fdputc(char ch,int fd);
EXPORT char *filebase(char *ifn);
EXPORT char *filepart(char *nm);
EXPORT ul find_hz_cross_over(short *samples,ul smp_n);
EXPORT char *findext(char *fn);
EXPORT ul g1brlstrcpy(char *dst,char *src,ul n);
EXPORT int get_ansi_len(char *buf,int *ch,int *x,int *y);
EXPORT ul get_ansi_lenx(char *buf,int *ch,int *x,int *y,int *ques);
EXPORT char *get_local_ip(char *ip);
EXPORT char *getfext(char *fn);
EXPORT ul handle_ansi(char *buf,ul n);
EXPORT void hexdump(int fd,void *b,ul n);
EXPORT int hms2secs(char *hms);
EXPORT ul ice12to10(void *out_buf,void *buf,ul b,ul bits_per_sample,ul out_chan);
#ifndef _d_use_inline
EXPORT uc is_stdfile(char *fn);
#endif
EXPORT int is_wordchar(int ch);
EXPORT void kbd_flush();
EXPORT char *local_ip(char *s);
EXPORT void lose_trailing_slash(char *fn);
EXPORT char *ltrim(char *b);
EXPORT ul midi2hz(ul num);
EXPORT void midi_write2(uc **ptr,us delta_tm,uc op,uc val);
EXPORT void midi_write3(uc **ptr,ul delta_tm,uc op,uc p,ul vel);
EXPORT int mkdir_parents(char *ifn);
EXPORT char **mkstridx(char *m,ul *n);
EXPORT void ms2timeval(ul tmo,timeval_t *t);
EXPORT int n_kgetch(uc ni);
EXPORT void *ntfs_attr_by_type(void *vmft,ul t);
EXPORT uc ntfs_is_dir(void *vmft);
EXPORT void *ntfs_next_attr(void *vm);
EXPORT int ntfs_read_mft(void *mft_rec,ul ix,ul clus_sz,int fd,void *b,ul rec_sz);
EXPORT ul ntfs_recno2sec(int fd,void *mft,ul recno,ul clus_sz,ul rec_sz);
EXPORT int ntfs_runlist_next(void **b,ul *lc,ul *vc);
EXPORT void *ntfs_vol_name(void *b);
EXPORT uc patmatch(char *s1,char *s2,uc igncase);
EXPORT void *pci_class_text(us cl);
EXPORT ul pci_read_class(us bus);
EXPORT us pcicfg_find_class(ul class,ul bus);
EXPORT us pcicfg_find_device(us vendor,us dev);
EXPORT us pcicfg_find_lpt();
EXPORT ul pcicfg_findfirst_class(ul cl);
EXPORT int pcicfg_scan_bus(void *vfoo);
EXPORT uc is_pe(char *b);
EXPORT image_file_header_t *pe_file_hdr(void *b);
EXPORT image_section_header_t *pe_sect_hdr(char *b,us n);
EXPORT image_optional_header_t *pe_opt_hdr(void  *mem);
EXPORT ul pe_get_checksum(void *mem,ul pelength);
EXPORT ul pe_calc_checksum(void *mem,ul pelength);
EXPORT ul pe_va2raw_offs(void *mem,ul va);
EXPORT image_section_header_t *pe_va2sect(ul va,void *img);
EXPORT char *phone2mbrola(char *ph);
EXPORT char *mbrola2phone(char *ph);
EXPORT uc pre_check_len(char *s1,char *s2,ul n);
#ifndef _d_use_inline
EXPORT int prints(char *b);
#if defined(WIN32)||defined(__DJGPP__)
#else
#endif
#endif
EXPORT int redirect_fd(int p,int fd);
EXPORT ul resample(short *isamples,short *osamples,ul israte,ul osrate,uc chans,ul inum_samples);
EXPORT ul resample_coarsen(void *b,ul num_samples,ul blk_sz,ul isps,ul osps,ul granularity);
EXPORT ul row_count(char *b);
EXPORT char *row_n_start(char *b,ul n);
EXPORT void rtrim(char *buf);
EXPORT uc rts_serial_connect(port_t uart,uc ch,ul tmo);
EXPORT int rts_serial_gets(port_t uart,void *buf,ul sz,ul tmo);
EXPORT uc rts_serial_listen(port_t uart,uc ch,ul tmo);
EXPORT int rts_serial_printf(port_t port,ul tmo,char *fmt,...);
EXPORT uc rts_serial_puts(port_t uart,void *buf,ul tmo);
EXPORT int rts_serial_read(port_t uart,void *buf,ul sz,ul tmo);
EXPORT int rts_serial_write(port_t uart,void *buf,ul sz,ul tmo);
EXPORT ul samp2deg(ul smp,ul srate,ul hz);
EXPORT void *search_strings(void *va,char *nm,uc ic);
EXPORT uc serial_connect(port_t uart,char ack_ch,ul max);
EXPORT int serial_print(port_t fd,void *str);
EXPORT int serial_printf(port_t port,char *fmt,...);
EXPORT int serial_sync4read(port_t fd,uc ack,ul max,ul pitch);
EXPORT int serial_sync4write(port_t fd,uc ack,ul max,ul pitch);
EXPORT int serial_wait_ready(port_t fd,char *str,ul tmo);
EXPORT void add_ext(char *fn,char *ext);
EXPORT void set_output_ext(char *ofn,char *ifn,char *newext);
EXPORT char *set_trailing_slash(char *fn);
EXPORT void shexdump(void *ob,void *b,ul n);
EXPORT char *skip_local_drive(char *fn);
EXPORT char *skip_network_drive(char *fn);
EXPORT char *skip_drive(char *fn);
EXPORT char *skipword(char **ptr);
EXPORT int spawnv1(int nowait,char *fn,char **av);
EXPORT ul speak_append_buf(void *ob,ul sz,void *b,ul n);
EXPORT void *str2wds(char *b,char *src,ul n);
EXPORT char *arg_extract(char **p);
EXPORT void string2args(char *buf,int *ac,char **av);
EXPORT void *string_start(char *str_start,char *ptr);
EXPORT void *strinstr(void *s1,void *s2,ul n3);
EXPORT void *stristr(void *s1,void *s2);
EXPORT int strnmatch(char *s1,char *s2);
EXPORT int strnimatch(char *s1,char *s2);
EXPORT int to_g1brl(int ch);
EXPORT ul g1brl2ascii(char ch);
EXPORT void trim(char *buf);
EXPORT char *char2xml(int ch);
EXPORT void *stradd(char **p,char *s,ul n);
EXPORT char *txt2xml(char *dst,char *src,ul n);
EXPORT char *unescape_char(char *ptr);
EXPORT char *unescape_string(char *ptr);
EXPORT char *usb_class2nm(uc cl);
EXPORT char *usb_class_asc(int cl);
EXPORT char *usb_ws2ascii(char *ascii,us *ws,ul max);
EXPORT char *usb_wstr2str(void *b);
EXPORT void verb_prints(char *buf);
EXPORT void verb_printsn(char *buf);
EXPORT int verb_write(char *buf,ul n);
#ifndef __stdddk_h
#endif
EXPORT char *w2ascii(us *wstr);
EXPORT int wait_rts(port_t h,uc state,ul ms);
EXPORT int wait_rts_clear(port_t h,ul ms);
EXPORT int wait_rts_set(port_t h,ul ms);
EXPORT ul wav_check_hdr(int fd,ul *samplerate,us *nchannels,us *bps);
EXPORT void wav_get_ext_data(int fd,ul offs,wavfilehdr_t *w);
EXPORT void whoop(ul diff);
EXPORT uc wordcmp(char *s1,char *s2);
#ifndef _d_use_inline
EXPORT uc wordicmp(char *s1,char *s2);
#endif
EXPORT us wordlen(char *s1);
EXPORT int write_midi0_hdr(int fd,ul n,ul divs,us fe1);
EXPORT int write_midi_event(int fd,us len,char *ev);
EXPORT ul x86bswap(ul n);
EXPORT void xdprintf(int fd,char *fmti,char tf,...);
EXPORT void *xfopen(char *f,char *m);
EXPORT int xread(int fd,void *b,ul sz);
EXPORT int xwrite(int fd,void *b,ul sz);
EXPORT void xlate_radix(char *fmt,char tf);
EXPORT us xpcicfg_find_device(us v,us d);
EXPORT void xprintf(void *fh,char *fmti,char tf,...);
EXPORT void xrts_serial_connect(port_t port,uc ch,ul tmo);
EXPORT int xrts_serial_gets(port_t uart,void *buf,ul sz,ul tmo);
EXPORT void xrts_serial_listen(port_t port,uc ch,ul tmo);
EXPORT int xrts_serial_printf(port_t port,ul tmo,char *fmt,...);
EXPORT void xrts_serial_puts(port_t port,char *ch,ul tmo);
EXPORT int xrts_serial_read(port_t port,void *buf,ul sz,ul tmo);
EXPORT int xrts_serial_write(port_t port,void *buf,ul sz,ul tmo);
EXPORT void xserial_connect(port_t uart,uc ch,ul tmo);
EXPORT void xserial_listen(port_t uart,uc ch,ul tmo);
EXPORT void xset_cts_rts(port_t uart,uc mode,ul tmo);
#ifndef _d_use_inline
EXPORT char *xstrdup(char *s);
#endif
EXPORT long xstrtol(char *s);
EXPORT ul xstrtoul(char *s);
EXPORT void *xtract_descriptor(uc type,uc ix,void *b);
EXPORT void xwait_rts(port_t uart,uc ch,ul tmo);
EXPORT int *__errno_location();
#ifdef WIN32
#else
#endif
EXPORT ul asc2ip(char *nm);
EXPORT ul clockticks();
EXPORT int dbg_write(char *fmt,int l);
EXPORT int dbg_print(char *fmt);
EXPORT int dbg_printf(char *fmt,...);
EXPORT uc dirwalk(char *d,int (*foo)(),void *lparm);
EXPORT uc is_reg(char *fn);
EXPORT uc is_dir(char *fn);
EXPORT void loadparms(char *fn,int *ac,char **av);
EXPORT void *__13_malloc(ul n);
EXPORT void __13_free(void *ptr);
EXPORT uc ntfs_check_bmap(int fd,void *vattr,ul cl_sz,ul cl,uc force_reload);
#ifdef WIN32
#endif
EXPORT void playnote_n(ul p,ul d);
EXPORT void *search_path(char *fn);
EXPORT int search_subdir(char *dir_fn,char *fn,fn_ptr_t foo);
#ifdef WIN32
#else
#endif
EXPORT int xrecv(int s,void *b,ul sz);
EXPORT int xsend(int s,void *b,ul sz);
EXPORT void xconnect(int sk,void *s,ul sz);
EXPORT int sock_accept(int sock,ul tmo);
#if WIN32
#else
#endif
#ifdef WIN32
#else
#endif
EXPORT int sock_connect(int sock,char *ip,us port);
EXPORT ul sock_get_dword(int sk,ul tmo);
#ifdef WIN32
#else
#endif
EXPORT int sock_getch(int sk,ul ms);
#ifdef WIN32
#else
#endif
EXPORT char *sock_gets(int sk,char *b,ul sz,ul tmo);
#ifdef WIN32
#else
#endif
EXPORT int sock_print(int sock,char *s);
#ifdef WIN32
#else
#endif
EXPORT ul sock_printf(int sock,char *fmt,...);
#ifndef WIN32
#endif
EXPORT int sock_raw();
#ifdef WIN32
#else
#endif
EXPORT int xsock_raw();
EXPORT int sock_readable(int sock,ul tmo);
#if WIN32
#else
#endif
#ifdef WIN32
EXPORT void sock_term(int rc,char *fmt,...);
#else
#endif
EXPORT int sock_writeable(int sock,ul tmo);
#if WIN32
#else
#endif
EXPORT int tcp_read(int cl_sk,void *mem,ul fsz,ul tmo);
#ifndef _d_use_inline
EXPORT void term_func(int rc,char *buf);
EXPORT void term(int rc,char *str,...);
#endif
EXPORT void   verb_printf(char *fmt,...);
EXPORT int wait_connect(int sock,us port,char *ip,ul tmo,uc ni);
EXPORT void writelog(char *fmt,...);
EXPORT void xlisten(int sock,int n);
#ifndef _d_use_inline
EXPORT int xopen(char *fn,int fl);
#endif
#ifndef _d_use_inline
#ifdef WIN32
#else
#endif
EXPORT int xrecvfrom(int s,char *buf,ul sz,sockaddr_in_t *saddr);
#endif
#ifndef _d_use_inline
#ifdef WIN32
#else
#endif
EXPORT int xsock_udp();
EXPORT int sock_bind(int sock,us port);
EXPORT void xsock_bind(int sock,us port);
EXPORT int xsock_tcp();
#endif
EXPORT uc xsock_accept(int sock,ul tmo);
EXPORT int xsock_connect(int s,char *ip,us p);
EXPORT uc xsock_readable(int sock,ul tmo);
EXPORT uc xsock_writeable(int sock,ul tmo);
EXPORT int xwait_accept(int sock,void *cl,int a,int b);
