// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef __lnxc_h
#define __lnxc_h

// stdlib.h neds this
#define __strtol_internal_defined 1
#include <stdarg.h>
#include "common-elf32.h"
#include <asm/termios.h>
#include "std_getopt.h"
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>

#define _d_usbfs "/proc/bus/usb"
#define _d_wi_max_num_fd 31
#define _d_spk_ramfs_dir "/dev/spk.d"
#define _d_spk_svr "/dev/spk-svr"
#define _d_spk_svr_ctl _d_spk_ramfs_dir "/spk-svr-ctl"
#define setmode(...) (0)
#undef putc

#ifndef _d_use_local_hdrs
#include <stdio.h>
#include <stdlib.h>
#else
#define FILE void
#define EOF -1
#endif
#include<string.h>
#ifndef _d_use_static
#include "linux-syscalls.h"
#endif
#define atol(a) atoi((a))
#define _d_conin "/dev/console"

#define EXPORT
#include "_stdelf32.h"
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "asmlib.h"
#define sock_term(a,...) term(a,__VA_ARGS__)
#define sock_close(a) close(a)
#define sock_init() (0)
#define sock_tidy() (0)
#include "inline-fns.h"
//#include "lib/liblib.h"


#define add_fd_set_max(fd,sl,mx)  { FD_SET((fd),&(sl)); \
   if((fd)>(mx)) (mx)=(fd); }

//#ifndef O_RDONLY
//#define O_RDONLY 0
//#endif

#ifndef O_LARGEFILE
#define O_LARGEFILE	0100000
#endif


#define _d_max_path 260
typedef struct {
 void *h;
  ul sz;
  void *buf,*ptr;
  ul fs;
} alsa_pcm_stream_t;

typedef int WSADATA ;
typedef struct timeval TIMEVAL;
struct linux_dirent_s {
	unsigned long	d_ino;
	unsigned long	d_off;
	unsigned short	d_reclen;
	char		d_name[1];
} attr_packed;
typedef struct linux_dirent_s linux_dirent_t;
#define CloseSocket(a) close(a)
#define xsysterm(a,b,...) term(a,b,__VA_ARGS__)

enum {P_WAIT,P_NOWAIT};
#ifndef _d_std_c
extern char **environ;
extern int termout;
extern nmalloc_t *nmalloc_start;
extern void *nmalloc_end;
extern us plain_map[];
extern us shift_map[];
#endif
#ifndef   O_BINARY
#define O_BINARY 0
#endif
#define  serial_write(a,b,c) write(a,b,c)
#define serial_putc(a,b) fdputc((a),(b))

typedef struct {
  void *dir,*dir1;
  char hub[_d_max_path],dev[_d_max_path],fn[_d_max_path];
}  usbfs_dev_t;

void strupr(char*);
void strlwr(char*);

#define _13_foo(a,b) a _13_##b() asm(#b); a _13_##b
#endif
