// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef __std_getopt_h
#define __std_getopt_h

#define delete_arg() \
  argc--; \
    if(argc>ix) \
      memmove(&argv[ix],&argv[ix+1],sizeof(char*)*(argc-ix));
#define GETOPT { int ix=0,jx=0,stopprocessing=0; \
  for(ix=1;ix<argc;ix++) { \
    if(*argv[ix]!='-')  \
      continue; \
    if(!argv[ix][1])  \
      continue; \
     for(jx=1;jx<strlen(argv[ix])&&(!stopprocessing);jx++) \
      switch (argv[ix][jx])    { \
  case '-': stopprocessing=1; break;
#define GETOPTITEM(a,b) case a: \
_d_getoptitem(a,b);
#define _d_getoptitem(a,b) \
        b++; \
        break;
#define GETOPTVALUE(a,b,...)    case a: \
  _d_getoptvalue(a,b,__VA_ARGS__)
#define _d_getoptvalue(a,b,...) \
  if(argv[ix][jx+1]) \
  b=__VA_ARGS__(&argv[ix][jx+1]); \
 else {  \
    delete_arg(); \
  b=__VA_ARGS__(argv[ix]); \
    } \
  jx=8192; \
  break; 
#define GETOPTEND(str)         \
   GETOPTDEFAULT(str) \
  GETOPTNEXT
#define GETOPTDEFAULT(str) \
case '?': \
   prints(str); \
  exit(1); \
        default: \
  printf("Unknown option %c\n%s",argv[ix][jx],str); \
exit(1);
#define GETOPTNEXT } \
  delete_arg(); \
      ix--;\
    if(stopprocessing) break; \
    argv[argc]=NULL; \
  } \
getopt_ignore_arg:; \
  }
#define GETOPTIGNORE(ch) \
  case ch: \
  _d_getoptignore
#define _d_getoptignore \
  goto getopt_ignore_arg;
#endif
