// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef _STDDEFS_H
#define _STDDEFS_H

#define uc2ul(ch) (((ul)(ch))&0xff)
#define getsel(sel) asm("mov %%"#sel",%%ax\nmov %%ax,%0":"=m"(sel));

#ifndef __GNUC__
#define inline __inline
#endif

#ifndef _TURBOC_
enum {rexec_port=65000,_d_tcpcon_port,_d_udpcon_port,_d_udpxfer_port,
_d_tcpxfer_port,_d_k9_port,_d_tcprun_port,
_d_tcprmtsh,_d_tcpsndsvr_port,_d_tcp_sapi_svr_port,_d_bochs_svr_port,_d_tcp_x5svr_port,
_d_udpspk_port=_d_tcp_x5svr_port+8,_d_osv_port,_d_umx_port,
_d_tcp_null_port};
#endif
enum {_d_sock_time_out=-2,_d_sock_eof};


#undef putc
#define putc(c) fputc((c),stdout)
#define printvar(p,n) fprintf(ofh,#n"="p,n)
#define xoffsetof(b,a) ((char*)(b)-(char*)(a))

#define FD_STDIN 0
#define FD_STDOUT 1
#define FD_STDERR 2
#define _d_file_notfound32 0x80000000
#define FILE_NOTFOUND 0x8000

#define _d_timed_out -1

#define skipspace(p) for(;isspace(*(p));(p)++)
#define skipspacenl(p) for(;isspacenl(*(p));(p)++)
#define fprints(f,s) fputs((s),(f))
#define DIGIT2HEXCH(ch) (((ch)<10)?(ch)+'0':(ch)+0x57)
#define HEXVAL(ch) ((isdigit(ch))?(ch)-'0':tolower((ch))-'a'+10)
#define WORDCHAR(a) is_wordchar((a))

#ifdef _d_lnx
#define _d_all_file_access 0777
#else
#define _d_all_file_access 0
#endif

#if defined(WIN32)||defined(_d_pm)
#define set_run_perm(a) (0)
#else
#define set_run_perm(a) chmod((a),0777);
#endif

#if defined(WIN32)||defined(_TURBOC_)
#define setbinary(a) setmode((a),O_BINARY)
#else
#define setbinary(a)  (0)
#endif
#define fh_fopen(a,b,c) fh_fopen_err(a,b,c,term)
#define fh_fopen_err(direction,default_handle,mode,proc) { \
  int fd; \
if(is_stdfile(direction##fn)) { \
  direction##fh=default_handle; \
  fd=fileno(direction##fh); \
  if(fd<3) \
   if(strchr(mode,'b')) \
      setbinary(fd); \
} \
else \
  if(!(direction##fh=fopen(direction##fn,mode))) \
    proc(1,"Can't open %s in mode %s",direction##fn,mode); \
  }

#ifndef WIN32
#define __open__(f,m) open((f),(m))
#endif

#define fd_open(a,b,c) fd_open_err(a,b,c,term)
#define fd_open_err(direction,default_handle,mode,proc) { \
if(is_stdfile(direction##fn)) { \
  direction##fd=default_handle; \
  if(mode&O_BINARY) \
  setbinary(direction##fd); \
   } \
else \
  if(((direction##fd=__open__(direction##fn,mode)))==-1) \
    proc(1,"Can't open %s in mode %x",direction##fn,mode); \
}

#define WMAIN(cmdline,argc,argv)  int argc=1;\
  char **argv=NULL;\
  {\
  uc exitloop=0; \
    char *ptr=strdup((cmdline)?cmdline:"");\
    if(!ptr) \
    term(1,"Error allocatign memory for stirng ptr");\
    if(!(argv=malloc(sizeof(char**)))) \
   term(1,"cant alloc memory in wmai"); \
    if(!(argv[0]=strdup("application"))) \
   term(1,"even more errors allocating memroy");\
    for(;*ptr;ptr++) {\
      char *startpos;\
      if(isspace(*ptr)) continue;\
      startpos=ptr;\
      if(*ptr=='\"') {\
        startpos++;\
        ptr++;\
        for(;*ptr!='\"';ptr++) {\
          if(!*ptr) break;\
          if(*ptr=='\\')    \
            if(ptr[1]=='\"') strcpy(ptr,&ptr[1]);\
        }\
      }else {\
        for(;!isspace(*ptr);ptr++)\
          if(!*ptr) break;\
      }\
  if(!*ptr) exitloop=1; \
      *ptr='\0';\
      ++argc;\
      if(!(argv=realloc(argv,argc*sizeof(char**)))) \
    term(1,"yet more erros allocating memory in wmain");\
      if(!(argv[argc-1]=strdup(startpos))) \
  term(1,"yup malloc problems");\
  if(exitloop) break; \
    }\
  }\
  if(!(argv=realloc(argv,(argc+1)*sizeof(char**)))) \
   term(1,"bored with memoryh problesm try this");\
  argv[argc]=NULL;

#define GETSTDHANDLES {\
  HANDLE   StdHandle;\
  int fd;\
    StdHandle=GetStdHandle(STD_OUTPUT_HANDLE);\
  fd=_open_osfhandle((long)StdHandle, _O_TEXT);\
  _fdopen( fd, "w" );\
  setvbuf( stdout, NULL, _IONBF, 0 );\
  StdHandle=GetStdHandle(STD_ERROR_HANDLE);\
  fd=_open_osfhandle((long)StdHandle, _O_TEXT);\
  _fdopen( fd, "w" );\
  setvbuf( stderr, NULL, _IONBF, 0 );\
  StdHandle=GetStdHandle(STD_INPUT_HANDLE);\
  fd=_open_osfhandle((long)StdHandle, _O_TEXT);\
  _fdopen( fd, "r" );\
  setvbuf( stdin, NULL, _IONBF, 0 );\
}

#define PERR(bSuccess, api){if(!(bSuccess)) printf("%s:Error %d from %s \
    on line %d\n", __FILE__, GetLastError(), api, __LINE__);}


enum {seek_set,seek_cur,seek_end};

#define divmod(a,b,d,m) asm("mov %2,%%eax\nmov %3,%%ecx\nxor %%edx,%%edx\n" \
"div %%ecx\nmov  %%eax,%0\nmov %%edx,%1" \
:"=m"(d),"=m"(m) \
:a,b)

#define rad(a) ((a)*M_PI/180)
#define deg(a) ((a)*180/M_PI)
#define _d_serial_time_out -1
#define _d_ic_time_out 500
#define _d_cts_rts_time_out2 2000

#define printreg(a) { \
     ul wibble; \
  asm("mov %%" #a ",%0"::"m"((wibble))); \
    printf(#a "=%x\n",wibble); \
}
#define getreg(a) \
  asm("mov %%" #a ",%0"::"m"((a)))
#define setreg(r,v) \
asm("mov %0,%%" #r::v)

#define add_fd_set_max(fd,sl,mx)  { FD_SET((fd),&(sl)); \
   if((fd)>(mx)) (mx)=(fd); }
#ifndef _d_max_path
#ifdef MAX_PATH
#define _d_max_path MAX_PATH
#else
#define _d_max_path 260
#endif
#endif

#define _d_log_nm "debug.log"

#define _d_sector_sz 0x200
#define _d_sector_shift 9

#define _d_fat_start_cluster_offset 2
#ifdef WIN32
#define _d_subdir _A_SUBDIR
#else
#define _d_subdir 0x10
#endif

#define xSetWindowsHookEx(rc,a,b,c,d) \
   if(!(rc=SetWindowsHookEx(a,(void*)b,c,d))) \
  term(1,"cant set hook " #a)

#define point_elsewhere(a,b) asm(".global " #a";"#a": jmp "#b)
#define dummy_fn(a) asm(".global " #a ";" #a ": mov $0,%eax;ret")

#define fsqrt asm("fsqrt")
#define pusha asm("pusha")
#define popa asm("popa")
#define int3() asm("int $0x3")
enum {_d_ier=1,_d_iir,_d_lcr,_d_mcr,_d_lsr,_d_msr};
#define	_d_kern_emerg	"<0>"	/* system is unusable			*/
#define	_d_kern_alert	"<1>"	/* action must be taken immediately	*/
#define	_d_kern_crit	"<2>"	/* critical conditions			*/
#define	_d_kern_err	"<3>"	/* error conditions			*/
#define	_d_kern_warning	"<4>"	/* warning conditions			*/
#define	_d_kern_notice	"<5>"	/* normal but significant condition	*/
#define	_d_kern_info	"<6>"	/* informational			*/
#define	_d_kern_debug	"<7>"	/* debug-level messages			*/

// needs to be accessible both from win32 user progs and ddk so put it here
#define buf_ioctl(b) \
    CTL_CODE( FILE_DEVICE_UNKNOWN,b,   \
        METHOD_BUFFERED, FILE_ANY_ACCESS )
#define unbuf_ioctl(b) \
    CTL_CODE(40000,b, METHOD_NEITHER , FILE_ANY_ACCESS  )

#define sym_dev(a) "\\\\.\\" a

#define sgdt(a) asm("sgdt %0"::"g"(a));
#define _d_create O_WRONLY|O_CREAT|O_TRUNC
#define _d_append O_WRONLY|O_CREAT|O_APPEND

#define _d_o_create O_WRONLY|O_CREAT|O_TRUNC
#define _d_cd_raw_sec_sz  2352
#define _d_cdrom_adjust 150

#define _d_vaargs(n,buf,bufn,fmt) \
  char buf[bufn]; \
    ul n; va_list vl; \
  va_start(vl,fmt); \
   n=vsnprintf(buf,bufn,fmt,vl); \
  va_end(vl);

#ifndef _d_lnx
#define _d_path_sep ';'
#else
#define _d_path_sep ':'
#endif

#define _d_brl6pt(a,b,ch) {a|(b<<3),ch}

#define _d_fat_clus_shift_limit 5760
#ifndef WIN32
#define WAVE_FORMAT_PCM 1
#define _13_mkdir(a) mkdir((a),0666)
#else
#define _13_mkdir mkdir
#endif

#define space_start(a,b) \
  for(;isspace(*b)&&(b>a);b--) if(!isspace(b[-1])) break;

#define _d_ext2_ndir_blocks		12
#define _d_ext2_ind_block			_d_ext2_ndir_blocks
#define _d_ext2_dind_block			(_d_ext2_ind_block + 1)
#define _d_ext2_tind_block			(_d_ext2_dind_block + 1)
#define _d_ext2_n_blocks			(_d_ext2_tind_block + 1)

#if defined(WIN32)||defined(__DJGPP__)
#define stat64(a,b) stat(a,b)
#endif

#define x86bswapw(a) x86bswapw32((a))

#if defined(WIN32)||defined(__DJGPP__)
#define stat_n(a,b) stat((a),(b))
#endif
#ifndef WIN32
#define SetConsoleTitle(a) (0)
#define IMAGE_NUMBEROF_DIRECTORY_ENTRIES 16
#define IMAGE_SIZEOF_SHORT_NAME 8
#define IMAGE_DOS_SIGNATURE 0x5A4D
#define IMAGE_OS2_SIGNATURE 0x454E
#define IMAGE_OS2_SIGNATURE_LE 0x454C
#define IMAGE_VXD_SIGNATURE 0x454C
#define IMAGE_NT_SIGNATURE 0x00004550
#define IMAGE_SEPARATE_DEBUG_SIGNATURE 0x4944
#define IS_TEXT_UNICODE_SIGNATURE 8
#define IS_TEXT_UNICODE_REVERSE_SIGNATURE 128

#define IMAGE_DIRECTORY_ENTRY_EXPORT	0
#define IMAGE_DIRECTORY_ENTRY_IMPORT	1
#define IMAGE_DIRECTORY_ENTRY_RESOURCE	2
#define IMAGE_DIRECTORY_ENTRY_EXCEPTION	3
#define IMAGE_DIRECTORY_ENTRY_SECURITY	4
#define IMAGE_DIRECTORY_ENTRY_BASERELOC	5
#define IMAGE_DIRECTORY_ENTRY_DEBUG	6
#define IMAGE_DIRECTORY_ENTRY_COPYRIGHT	7
#define IMAGE_DIRECTORY_ENTRY_ARCHITECTURE	7
#define IMAGE_DIRECTORY_ENTRY_GLOBALPTR	8
#define IMAGE_DIRECTORY_ENTRY_TLS	9
#define IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG	10
#define IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT	11
#define IMAGE_DIRECTORY_ENTRY_IAT	12
#define IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT	13
#define IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR	14
#endif

#endif

#define _d_attr(a) __attribute__(((a)))
#define BMP_CTAB_OFFSET 54
