// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#ifndef _STDHDR_H
#define _STDHDR_H

#ifdef __cplusplus
extern "C" {
#endif
#ifdef WIN32
#include "stdhdr-w32.h"
#elif defined __DJGPP__
#include "stdhdr-dj32.h"
#elif defined(_d_pm)
#include "pm5.h"
#elif defined(_d_code16gcc)
#include "stdgcc16.h"
#else
#include "lnxc.h"
#endif

#ifdef __cplusplus
}
#endif
#endif
