// addmzhdr, add mz header to a 16 bit .bin file to create an mz .exe file
// Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
EXPORT int termout=STDERR_FILENO;

#ifndef _d_use_inline
void term_func(int rc,char *buf) {
  fdprints(termout,buf);
  if(!isatty(termout))
  close(termout);
exit(rc);
}
EXPORT fn_ptr_t term_func_ptr=(fn_ptr_t)term_func;
void term(int rc,char *str,...)  {
  char buf[255];
  va_list vl ;

  va_start(vl,str);
  vsnprintf(buf,sizeof(buf),str,vl);
  va_end(vl);
  strcat(buf,"\n");
    (term_func_ptr)(rc,buf);
}
#endif
